import Tabs from '@/components/Tabs';
import ToggleView from '@/components/ToggleView';
import BaseCard from '@/pages/Common/components/BaseCard';
import EventPicList from '@/pages/Common/components/EventPicList';
import ListView from '@/pages/Common/components/ListView';
import ProcessCard from '@/pages/Common/components/ProcessCard';
import services from '@/services';
import { Flex, Space } from 'antd';
import { useEffect, useRef, useState } from 'react';
import { GlobalModalServicesModalMethods } from '../../type';
import styles from './index.less';
import LineCharts from './LineCharts';

const CgftEvent = ({
  singleType,
  modalDispatch,
  sourceSystemCode,
  datetType,
  lineData
}: {
  singleType: string;
  modalDispatch: GlobalModalServicesModalMethods;
  sourceSystemCode:string
  datetType:string;
  lineData:any[]
}) => {
  // 视图
  // const [viewType, setViewType] = useState<'list' | 'pic'>('pic'); //展示
  const viewType = useRef<'list' | 'pic'>('pic');

  const fetchParams = useRef({
    page: 1,
    count: 10,
    singleType,
    caseStatus: '',
    sourceSystemCode,
    type:datetType
  });

  //事件列表
  const [listData, setListData] = useState<any>({
    items: [],
    loading: true,
    total: 0,
    page: 1,
    hasNext: false,
  });

  const [eventStatistics, setEventStatistics] = useState<any>({});
  const [categoryStatistics, setCategoryStatistics] = useState([]);
  const [areaStatistics, setAreaStatistics] = useState([]);
  const [importEventStatistics, setImportEventStatistics] = useState([]);

  // 获取左侧顶部事件相关统计
  const getCityStatistics = () => {
    const params = {
      singleType,
      sourceSystemCode,
      type:datetType
    };
    services.CityProblemApi.getContentStatisticsApi(params).then((res) => {
      if (res.code === 200) {
        setEventStatistics(res.data);
      }
    });
  };

  // 高发类别统计
  const getCategoryAnalysis = (category = 'mainClass') => {
    const params = {
      category: category,
      top: 3,
      singleType,
      sourceSystemCode,
      type:datetType
    };
    services.CityProblemApi.getCategoryTopAnalysisApi(params).then((res) => {
      if (res.code === 200) {
        setCategoryStatistics(res.data);
      }
    });
  };

  const onChangeCategory = (value: string) => {
    getCategoryAnalysis(value);
  };

  // 高发类别统计
  const getAreaAnalysis = () => {
    const params = {
      region: 'district',
      top: 3,
      singleType,
      sourceSystemCode,
      type:datetType
    };
    services.CityProblemApi.getAreaDistribAnalysisApi(params).then((res) => {
      if (res.code === 200) {
        setAreaStatistics(res.data);
      }
    });
  };

  // 事件列表
  const getEventsList = () => {
    services.CityProblemApi.getZzEventListApi(fetchParams.current).then(
      (res) => {
        if (res.code === 200) {
          if (viewType.current === 'list') {
            setListData(res.data);
          } else {
            let result = {
              ...res.data,
              items:
                fetchParams.current.page === 1
                  ? res.data.items
                  : [...listData.items, ...res.data.items],
            };
            setListData(result);
          }
        }
      },
    );
  };

  // 事件统计
  const getImportEventStatistics = () => {
    const params = {
      singleType,
      sourceSystemCode,
      type:datetType
    };
    services.CityProblemApi.getImportEventStatisticsApi(params).then((res) => {
      if (res.code === 200) {
        const result = res.data.map((item: any) => {
          return {
            label: `${item.case_status_name} ${item.total}`,
            key: item.case_status,
          };
        });
        setImportEventStatistics(result);
        fetchParams.current.caseStatus = result[0]?.key;
        getEventsList();
      }
    });
  };

  const changeListTab = (value: string) => {
    fetchParams.current.caseStatus = value;
    fetchParams.current.page = 1;
    setListData({
      items: [],
      loading: true,
      total: 0,
      page: 1,
      hasNext: false,
    });
    getEventsList();
  };

  useEffect(() => {
    getCityStatistics();
    getCategoryAnalysis();
    getAreaAnalysis();
    getImportEventStatistics();
  }, []);

  return (
    <Flex gap={30} className={styles.wrap}>
      <Space direction="vertical" size={15} className={styles.left}>
        <BaseCard
          style={{
            paddingTop: 15,
          }}
        >
          <Flex justify="space-between" className={styles.top}>
            <Space direction="vertical">
              <span>
                <span className={styles.num}>{eventStatistics.total}</span>
                <span>件</span>
              </span>
              <span>总量</span>
            </Space>
            <Space direction="vertical">
              <span>
                <span className={styles.num}>
                  {eventStatistics.caseClosedNum}
                </span>
                <span>件</span>
              </span>
              <span>已办结</span>
            </Space>
            <Space direction="vertical">
              <span>
                <span className={styles.num}>{eventStatistics.ratio}</span>
                <span>%</span>
              </span>
              <span>办结率</span>
            </Space>
          </Flex>
        </BaseCard>

        <BaseCard
          title="趋势（近30天）"
          style={{
            paddingTop: 20,
          }}
        >
          <div style={{ padding: '15px', width: '100%', height: '100%' }}>
            {/* <LineCharts data={eventStatistics.lately} /> */}
            <LineCharts data={lineData}></LineCharts>
          </div>
        </BaseCard>

        <ProcessCard
          title="高发类别"
          extra={
            <Tabs
              style={{
                background: 'transparent',
                height: '30px',
              }}
              itemStyle={{
                borderRadius: '25px',
                background: 'rgba(7, 50, 93, 0.8)',
                fontSize: '16px',
                marginLeft: 8,
              }}
              onChange={onChangeCategory}
              itemkey={'key'}
              items={[
                {
                  key: 'mainClass',
                  label: '大类',
                },
                {
                  key: 'subClass',
                  label: '小类',
                },
                {
                  key: 'subdivisionClass',
                  label: '细类',
                },
              ]}
            />
          }
          data={categoryStatistics}
          strokeColor={{
            '0%': '#38F2E3',
            '100%': '#3DC3FF',
          }}
        />

        <ProcessCard
          title="高发区域"
          data={areaStatistics}
          strokeColor={{
            '0%': '#FFCCCC',
            '100%': '#EEFFEB',
          }}
        />
      </Space>
      <div className={styles.right}>
        <Flex justify="flex-end" style={{ marginBottom: 20 }}>
          <Space size={20}>
            <Tabs
              onChange={changeListTab}
              itemkey={'key'}
              items={importEventStatistics}
            />
            <ToggleView
              type={viewType.current}
              setType={(type) => {
                viewType.current = type;
                fetchParams.current.page = 1;
                setListData({
                  items: [],
                  loading: true,
                  total: 0,
                  page: 1,
                  hasNext: false,
                });
                getEventsList();
              }}
            />
          </Space>
        </Flex>
        {viewType.current === 'list' ? (
          <ListView
            listData={listData}
            listHeight={540}
            setParams={(data) => {
              fetchParams.current.page = data.pageNum;
              fetchParams.current.count = data.pageSize;
              getEventsList();
            }}
            handleDetail={(details) => {
              modalDispatch.push(
                'EventDetail',
                {
                  props: {
                    eventId: details.eventId,
                  },
                },
                1,
              );
            }}
          />
        ) : (
          <EventPicList
            listData={listData}
            listHeight={640}
            setParams={(page) => {
              fetchParams.current.page = page;
              getEventsList();
            }}
            handleDetail={(details) => {
              modalDispatch.push(
                'EventDetail',
                {
                  w: 'fit-content',
                  props: {
                    eventId: details.eventId,
                  },
                },
                1,
              );
            }}
          />
        )}
      </div>
    </Flex>
  );
};

export default CgftEvent;
